package com.qhtx.eta.common.eunms;

import lombok.Getter;

@Getter
public enum ETARetryEnum {
    SERVICE_UNAVAILABLE(503, "服务不可用"),
    GATEWAY_TIMEOUT(504, "网关超时"),
    NOT_FOUND(404, "服务不存在"),
    ;
    private int code;
    private String desc;

    ETARetryEnum(int code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static boolean needRetry(int code) {
        for (ETARetryEnum etaRetryEnum : ETARetryEnum.values()) {
            if (etaRetryEnum.code == code) {
                return true;
            }
        }
        return false;
    }
}
