package com.qhtx.eta.common.utils;

public class MapUtils {

    /**
     * 将大写下划线格式的字符串转换为驼峰格式。
     *
     * @param underscoreStr 大写下划线格式的字符串
     * @return 驼峰格式的字符串
     */
    public static String underscoreToCamelCase(String underscoreStr, boolean IgnoreUpperCase) {
        if (underscoreStr == null || underscoreStr.isEmpty()) {
            return underscoreStr;
        }
        StringBuilder camelCaseStr = new StringBuilder();
        boolean nextUpperCase = false; // 标记是否需要将下一个字符转换为大写

        for (char ch : underscoreStr.toCharArray()) {
            if (ch == '_') {
                nextUpperCase = true; // 遇到下划线，标记下一个字符需要转大写
            } else {
                if (nextUpperCase) {
                    camelCaseStr.append(Character.toUpperCase(ch)); // 转换为大写并添加到结果中
                    nextUpperCase = false; // 重置标记
                } else {
                    camelCaseStr.append(IgnoreUpperCase ? Character.toLowerCase(ch) : ch); // 第一个字符小写，其余保持原样
                }
            }
        }
        return camelCaseStr.toString();
    }
}
