package com.qhtx.eta.domain.config;

import com.qhtx.eta.common.constant.ETAConstants;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.List;
import java.util.concurrent.*;

/**
 * 线程池的config管理
 *
 * @author: ChickenWing
 * @date: 2023/11/26
 */
@Configuration
public class ThreadPoolConfig {

    @Bean(name = "ETAInfoThreadPool")
    public ThreadPoolExecutor etaInfoThreadPool() {
        return new ThreadPoolExecutor(10, 20, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(40), new ETAThreadFactory(ETAConstants.THREAD_POOL_ETA_INFO), new ThreadPoolExecutor.CallerRunsPolicy());
    }

    @Bean(name = "IndexSyncThreadPool")
    public ThreadPoolExecutor indexSyncThreadPool() {
        return new ThreadPoolExecutor(10, 20, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(40), new ETAThreadFactory(ETAConstants.THREAD_POOL_ETA_INFO), new ThreadPoolExecutor.CallerRunsPolicy());
    }

    @Bean(name = "ETADataThreadPool")
    public ThreadPoolExecutor etaDataThreadPool() {
        return new ThreadPoolExecutor(10, 20, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(40), new ETAThreadFactory(ETAConstants.THREAD_POOL_ETA_DATA), new ThreadPoolExecutor.CallerRunsPolicy());
    }

    @Bean(name = "ETAClassifyThreadPool")
    public ThreadPoolExecutor etaClassifyThreadPool() {
        return new ThreadPoolExecutor(10, 20, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(40), new ETAThreadFactory(ETAConstants.THREAD_POOL_ETA_CLASSIFY), new ThreadPoolExecutor.CallerRunsPolicy());
    }

    @Bean(name = "IndexFrameThreadPool")
    public ThreadPoolExecutor etaIndexFrameThreadPool() {
        return new ThreadPoolExecutor(1, 1, 0, TimeUnit.SECONDS, new LinkedBlockingDeque<>(1), new ETAThreadFactory(ETAConstants.THREAD_POOL_INDEX_FRAME), new ThreadPoolExecutor.CallerRunsPolicy());
    }

    @Bean(name = "IndexDataThreadPool")
    public ThreadPoolExecutor etaIndexDataThreadPool() {
        return new ThreadPoolExecutor(10, 20, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(40), new ETAThreadFactory(ETAConstants.THREAD_POOL_INDEX_DATA), new ThreadPoolExecutor.CallerRunsPolicy());
    }
}
