package com.qhtx.eta.domain.convert;

import com.qhtx.eta.domain.api.http.request.ETAPushData;
import com.qhtx.eta.domain.entity.DWIndexDataDTO;
import com.qhtx.eta.infra.entity.dw.TDampDwIndexData;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;
import org.mapstruct.factory.Mappers;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Mapper
public interface DWIndexDataDTOConverter {

    DWIndexDataDTOConverter INSTANCE = Mappers.getMapper(DWIndexDataDTOConverter.class);

    @Mapping(source = "dataDate", target = "date")
    @Mapping(source = "dataValue", target = "value")
    DWIndexDataDTO convertToDTO(TDampDwIndexData dwIndexData);


    @Mapping(source = "dataDate", target = "date")
    @Mapping(source = "dataValue", target = "value")
    List<DWIndexDataDTO> convertToDTOList(List<TDampDwIndexData> dwIndexData);

    @Named("dateToString")
    default String dateToString(Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return date != null ? sdf.format(date) : null;
    }


    @Mapping(source = "date", target = "date", qualifiedByName = "dateToString")
    ETAPushData convertToETAPushData(DWIndexDataDTO dwIndexData);

    List<ETAPushData> convertToETAPushDataList(List<DWIndexDataDTO> dwIndexData);
}
