package com.qhtx.eta.infra.enums;

import lombok.Getter;

@Getter
public enum Frequency {
    DAILY(1, "日度"),
    WEEKLY(2, "周度"),
    MONTHLY(3, "月度"),
    QUARTERLY(6, "季度"),
    DECADELY(7, "旬度"),
    YEARLY(4, "年度"),
    SEMI_ANNUAL(5, "半年度"),
    ;


    private int value;
    private String desc;

    Frequency(int value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public static Frequency getFrequencyByDesc(String desc) {
        for (Frequency frequency : Frequency.values()) {
            if (frequency.getDesc().equals(desc)) {
                return frequency;
            }
        }
        return null;
    }
}
