package com.qhtx.eta.infra.service.impl;

import com.qhtx.eta.common.annotation.DataOperator;
import com.qhtx.eta.infra.annotation.UseDataSource;
import com.qhtx.eta.infra.entity.ods.EtaApiQuotaData;
import com.qhtx.eta.infra.mapper.EtaApiQuotaDataDao;
import com.qhtx.eta.infra.service.EtaApiQuotaDataService;
import com.qhtx.eta.common.eunms.DataSourceType;
import com.qhtx.eta.common.eunms.ETAApiType;
import lombok.extern.slf4j.Slf4j;
import org.jetbrains.annotations.NotNull;
import org.springframework.stereotype.Service;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.TransactionCallbackWithoutResult;
import org.springframework.transaction.support.TransactionTemplate;

import javax.annotation.Resource;
import java.util.List;

/**
 * (EtaApiQuotaData)表服务实现类
 *
 * @author makejava
 * @since 2024-04-29 13:52:15
 */
@Service("etaApiQuotaDataService")
@UseDataSource(dataSourceType = DataSourceType.ODS)
@Slf4j
public class EtaApiQuotaDataServiceImpl implements EtaApiQuotaDataService {
    @Resource
    private EtaApiQuotaDataDao etaApiQuotaDataDao;

    @Resource
    private TransactionTemplate transactionTemplate;

    @Override
    public List<EtaApiQuotaData> getAllLatestDataByUniqueCode() {
        return etaApiQuotaDataDao.getAllLatestDataByUniqueCode();
    }

    @Override
    public EtaApiQuotaData getLatestDataByUniqueCode(String uniqueCode) {
        return this.etaApiQuotaDataDao.getLatestDataByUniqueCode(uniqueCode);
    }

    @Override
    @DataOperator(apiType = ETAApiType.DATA, fields = {"uniqueCode"}, dataType = EtaApiQuotaData.class)
    public void batchInsert(List<EtaApiQuotaData> dataList) {
        transactionTemplate.execute(new TransactionCallbackWithoutResult() {
            @Override
            protected void doInTransactionWithoutResult(@NotNull TransactionStatus transactionStatus) {
                etaApiQuotaDataDao.insertBatch(dataList);
            }
        });

    }
}
